from typing import List, Optional, Dict, Iterable
import aspose.pycore
import aspose.pydrawing
import aspose.psd
import aspose.psd.asynctask
import aspose.psd.brushes
import aspose.psd.coreexceptions
import aspose.psd.coreexceptions.compressors
import aspose.psd.coreexceptions.imageformats
import aspose.psd.customfonthandler
import aspose.psd.dithering
import aspose.psd.evalute
import aspose.psd.exif
import aspose.psd.exif.enums
import aspose.psd.extensions
import aspose.psd.fileformats
import aspose.psd.fileformats.ai
import aspose.psd.fileformats.bmp
import aspose.psd.fileformats.core
import aspose.psd.fileformats.core.blending
import aspose.psd.fileformats.core.vectorpaths
import aspose.psd.fileformats.jpeg
import aspose.psd.fileformats.jpeg2000
import aspose.psd.fileformats.pdf
import aspose.psd.fileformats.png
import aspose.psd.fileformats.psd
import aspose.psd.fileformats.psd.core
import aspose.psd.fileformats.psd.core.rawcolor
import aspose.psd.fileformats.psd.layers
import aspose.psd.fileformats.psd.layers.adjustmentlayers
import aspose.psd.fileformats.psd.layers.animation
import aspose.psd.fileformats.psd.layers.filllayers
import aspose.psd.fileformats.psd.layers.fillsettings
import aspose.psd.fileformats.psd.layers.gradient
import aspose.psd.fileformats.psd.layers.layereffects
import aspose.psd.fileformats.psd.layers.layerresources
import aspose.psd.fileformats.psd.layers.layerresources.lfx2resources
import aspose.psd.fileformats.psd.layers.layerresources.strokeresources
import aspose.psd.fileformats.psd.layers.layerresources.typetoolinfostructures
import aspose.psd.fileformats.psd.layers.smartfilters
import aspose.psd.fileformats.psd.layers.smartfilters.rendering
import aspose.psd.fileformats.psd.layers.smartobjects
import aspose.psd.fileformats.psd.layers.text
import aspose.psd.fileformats.psd.resources
import aspose.psd.fileformats.psd.resources.enums
import aspose.psd.fileformats.psd.resources.resolutionenums
import aspose.psd.fileformats.tiff
import aspose.psd.fileformats.tiff.enums
import aspose.psd.fileformats.tiff.filemanagement
import aspose.psd.flatarray
import aspose.psd.flatarray.exceptions
import aspose.psd.imagefilters
import aspose.psd.imagefilters.filteroptions
import aspose.psd.imageloadoptions
import aspose.psd.imageoptions
import aspose.psd.interfaces
import aspose.psd.memorymanagement
import aspose.psd.multithreading
import aspose.psd.palettehelper
import aspose.psd.progressmanagement
import aspose.psd.shapes
import aspose.psd.shapesegments
import aspose.psd.sources
import aspose.psd.xmp
import aspose.psd.xmp.schemas
import aspose.psd.xmp.schemas.dublincore
import aspose.psd.xmp.schemas.pdf
import aspose.psd.xmp.schemas.photoshop
import aspose.psd.xmp.schemas.xmpbaseschema
import aspose.psd.xmp.schemas.xmpdm
import aspose.psd.xmp.schemas.xmpmm
import aspose.psd.xmp.schemas.xmprm
import aspose.psd.xmp.types
import aspose.psd.xmp.types.basic
import aspose.psd.xmp.types.complex
import aspose.psd.xmp.types.complex.colorant
import aspose.psd.xmp.types.complex.dimensions
import aspose.psd.xmp.types.complex.font
import aspose.psd.xmp.types.complex.resourceevent
import aspose.psd.xmp.types.complex.resourceref
import aspose.psd.xmp.types.complex.thumbnail
import aspose.psd.xmp.types.complex.version
import aspose.psd.xmp.types.derived

class BaseFillSettings(IFillSettings):
    '''Base fill effect settings'''
    
    @property
    def fill_type(self) -> aspose.psd.fileformats.psd.layers.fillsettings.FillType:
        ...
    
    ...

class BaseGradientFillSettings(BaseFillSettings):
    '''Base gradient definition class. It contains common properties for both tupes of gradient (Solid and Noise).'''
    
    @property
    def fill_type(self) -> aspose.psd.fileformats.psd.layers.fillsettings.FillType:
        ...
    
    @property
    def align_with_layer(self) -> bool:
        ...
    
    @align_with_layer.setter
    def align_with_layer(self, value : bool):
        ...
    
    @property
    def dither(self) -> bool:
        '''Gets a value indicating whether this :py:class:`aspose.psd.fileformats.psd.layers.fillsettings.BaseGradientFillSettings` is dither.'''
        ...
    
    @dither.setter
    def dither(self, value : bool):
        '''Sets a value indicating whether this :py:class:`aspose.psd.fileformats.psd.layers.fillsettings.BaseGradientFillSettings` is dither.'''
        ...
    
    @property
    def reverse(self) -> bool:
        '''Gets a value indicating whether this :py:class:`aspose.psd.fileformats.psd.layers.fillsettings.BaseGradientFillSettings` is reverse.'''
        ...
    
    @reverse.setter
    def reverse(self, value : bool):
        '''Sets a value indicating whether this :py:class:`aspose.psd.fileformats.psd.layers.fillsettings.BaseGradientFillSettings` is reverse.'''
        ...
    
    @property
    def angle(self) -> float:
        '''Gets the angle.'''
        ...
    
    @angle.setter
    def angle(self, value : float):
        '''Sets the angle.'''
        ...
    
    @property
    def scale(self) -> int:
        '''Gets the scale.'''
        ...
    
    @scale.setter
    def scale(self, value : int):
        '''Sets the scale.'''
        ...
    
    @property
    def horizontal_offset(self) -> float:
        ...
    
    @horizontal_offset.setter
    def horizontal_offset(self, value : float):
        ...
    
    @property
    def vertical_offset(self) -> float:
        ...
    
    @vertical_offset.setter
    def vertical_offset(self, value : float):
        ...
    
    @property
    def gradient_type(self) -> aspose.psd.fileformats.psd.layers.fillsettings.GradientType:
        ...
    
    @gradient_type.setter
    def gradient_type(self, value : aspose.psd.fileformats.psd.layers.fillsettings.GradientType):
        ...
    
    @property
    def gradient_mode(self) -> aspose.psd.fileformats.psd.layers.gradient.GradientKind:
        ...
    
    @gradient_mode.setter
    def gradient_mode(self, value : aspose.psd.fileformats.psd.layers.gradient.GradientKind):
        ...
    
    @property
    def color_points(self) -> List[aspose.psd.fileformats.psd.layers.IGradientColorPoint]:
        ...
    
    @color_points.setter
    def color_points(self, value : List[aspose.psd.fileformats.psd.layers.IGradientColorPoint]):
        ...
    
    @property
    def transparency_points(self) -> List[aspose.psd.fileformats.psd.layers.fillsettings.IGradientTransparencyPoint]:
        ...
    
    @transparency_points.setter
    def transparency_points(self, value : List[aspose.psd.fileformats.psd.layers.fillsettings.IGradientTransparencyPoint]):
        ...
    
    @property
    def gradient_name(self) -> str:
        ...
    
    @gradient_name.setter
    def gradient_name(self, value : str):
        ...
    
    @property
    def color(self) -> aspose.psd.Color:
        '''Gets the color.'''
        ...
    
    @color.setter
    def color(self, value : aspose.psd.Color):
        '''Sets the color.'''
        ...
    
    ...

class ColorFillSettings(BaseFillSettings):
    '''Color fill effect settings'''
    
    @property
    def fill_type(self) -> aspose.psd.fileformats.psd.layers.fillsettings.FillType:
        ...
    
    @property
    def color(self) -> aspose.psd.Color:
        '''Gets the color.'''
        ...
    
    @color.setter
    def color(self, value : aspose.psd.Color):
        '''Sets the color.'''
        ...
    
    ...

class GradientColorPoint(aspose.psd.fileformats.psd.layers.IGradientColorPoint):
    '''The Gradient Color Point.'''
    
    @property
    def color(self) -> aspose.psd.Color:
        '''Gets the color.'''
        ...
    
    @color.setter
    def color(self, value : aspose.psd.Color):
        '''Sets the color.'''
        ...
    
    @property
    def location(self) -> int:
        '''Gets the point location on gradient.'''
        ...
    
    @location.setter
    def location(self, value : int):
        '''Sets the point location on gradient.'''
        ...
    
    @property
    def median_point_location(self) -> int:
        ...
    
    @median_point_location.setter
    def median_point_location(self, value : int):
        ...
    
    @property
    def raw_color(self) -> aspose.psd.fileformats.psd.core.rawcolor.RawColor:
        ...
    
    @raw_color.setter
    def raw_color(self, value : aspose.psd.fileformats.psd.core.rawcolor.RawColor):
        ...
    
    @property
    def color_mode(self) -> int:
        ...
    
    @color_mode.setter
    def color_mode(self, value : int):
        ...
    
    ...

class GradientFillSettings(BaseGradientFillSettings):
    '''Gradient fill effect settings.'''
    
    @staticmethod
    def generate_lfx_2_resource_nodes() -> List[aspose.psd.fileformats.psd.layers.layerresources.OSTypeStructure]:
        '''Generates the LFX2 resource nodes.
        
        :returns: Generated List of :py:class:`aspose.psd.fileformats.psd.layers.layerresources.OSTypeStructure`'''
        ...
    
    def add_color_point(self) -> aspose.psd.fileformats.psd.layers.fillsettings.GradientColorPoint:
        '''Adds the color point.
        
        :returns: Created color point'''
        ...
    
    def add_transparency_point(self) -> aspose.psd.fileformats.psd.layers.fillsettings.GradientTransparencyPoint:
        '''Adds the color point.
        
        :returns: Created transparency point'''
        ...
    
    def remove_transparency_point(self, point : aspose.psd.fileformats.psd.layers.fillsettings.IGradientTransparencyPoint):
        '''Removes the transparency point.
        
        :param point: The point.'''
        ...
    
    def remove_color_point(self, point : aspose.psd.fileformats.psd.layers.IGradientColorPoint):
        '''Removes the color point.
        
        :param point: The point.'''
        ...
    
    @property
    def fill_type(self) -> aspose.psd.fileformats.psd.layers.fillsettings.FillType:
        ...
    
    @property
    def align_with_layer(self) -> bool:
        ...
    
    @align_with_layer.setter
    def align_with_layer(self, value : bool):
        ...
    
    @property
    def dither(self) -> bool:
        '''Gets a value indicating whether this :py:class:`aspose.psd.fileformats.psd.layers.fillsettings.BaseGradientFillSettings` is dither.'''
        ...
    
    @dither.setter
    def dither(self, value : bool):
        '''Sets a value indicating whether this :py:class:`aspose.psd.fileformats.psd.layers.fillsettings.BaseGradientFillSettings` is dither.'''
        ...
    
    @property
    def reverse(self) -> bool:
        '''Gets a value indicating whether this :py:class:`aspose.psd.fileformats.psd.layers.fillsettings.BaseGradientFillSettings` is reverse.'''
        ...
    
    @reverse.setter
    def reverse(self, value : bool):
        '''Sets a value indicating whether this :py:class:`aspose.psd.fileformats.psd.layers.fillsettings.BaseGradientFillSettings` is reverse.'''
        ...
    
    @property
    def angle(self) -> float:
        '''Gets the angle.'''
        ...
    
    @angle.setter
    def angle(self, value : float):
        '''Sets the angle.'''
        ...
    
    @property
    def scale(self) -> int:
        '''Gets the scale.'''
        ...
    
    @scale.setter
    def scale(self, value : int):
        '''Sets the scale.'''
        ...
    
    @property
    def horizontal_offset(self) -> float:
        ...
    
    @horizontal_offset.setter
    def horizontal_offset(self, value : float):
        ...
    
    @property
    def vertical_offset(self) -> float:
        ...
    
    @vertical_offset.setter
    def vertical_offset(self, value : float):
        ...
    
    @property
    def gradient_type(self) -> aspose.psd.fileformats.psd.layers.fillsettings.GradientType:
        ...
    
    @gradient_type.setter
    def gradient_type(self, value : aspose.psd.fileformats.psd.layers.fillsettings.GradientType):
        ...
    
    @property
    def gradient_mode(self) -> aspose.psd.fileformats.psd.layers.gradient.GradientKind:
        ...
    
    @gradient_mode.setter
    def gradient_mode(self, value : aspose.psd.fileformats.psd.layers.gradient.GradientKind):
        ...
    
    @property
    def color_points(self) -> List[aspose.psd.fileformats.psd.layers.IGradientColorPoint]:
        ...
    
    @color_points.setter
    def color_points(self, value : List[aspose.psd.fileformats.psd.layers.IGradientColorPoint]):
        ...
    
    @property
    def transparency_points(self) -> List[aspose.psd.fileformats.psd.layers.fillsettings.IGradientTransparencyPoint]:
        ...
    
    @transparency_points.setter
    def transparency_points(self, value : List[aspose.psd.fileformats.psd.layers.fillsettings.IGradientTransparencyPoint]):
        ...
    
    @property
    def gradient_name(self) -> str:
        ...
    
    @gradient_name.setter
    def gradient_name(self, value : str):
        ...
    
    @property
    def color(self) -> aspose.psd.Color:
        '''Gets the color.'''
        ...
    
    @color.setter
    def color(self, value : aspose.psd.Color):
        '''Sets the color.'''
        ...
    
    @property
    def interpolation(self) -> int:
        '''Interpolation. Determines Smoothness, when 'Gradient Type' = 'Solid'. Value range: 0-4096.'''
        ...
    
    @interpolation.setter
    def interpolation(self, value : int):
        '''Interpolation. Determines Smoothness, when 'Gradient Type' = 'Solid'. Value range: 0-4096.'''
        ...
    
    ...

class GradientTransparencyPoint(IGradientTransparencyPoint):
    '''Gradient Transparency Point'''
    
    @property
    def opacity(self) -> float:
        '''Gets the color.'''
        ...
    
    @opacity.setter
    def opacity(self, value : float):
        '''Sets the color.'''
        ...
    
    @property
    def location(self) -> int:
        '''Gets the location.'''
        ...
    
    @location.setter
    def location(self, value : int):
        '''Sets the location.'''
        ...
    
    @property
    def median_point_location(self) -> int:
        ...
    
    @median_point_location.setter
    def median_point_location(self, value : int):
        ...
    
    ...

class IColorFillSettings(IFillSettings):
    '''Base interface for fill settings'''
    
    @property
    def color(self) -> aspose.psd.Color:
        '''Gets the color.'''
        ...
    
    @color.setter
    def color(self, value : aspose.psd.Color):
        '''Sets the color.'''
        ...
    
    @property
    def fill_type(self) -> aspose.psd.fileformats.psd.layers.fillsettings.FillType:
        ...
    
    ...

class IFillSettings:
    '''Base interface for fill settings'''
    
    @property
    def fill_type(self) -> aspose.psd.fileformats.psd.layers.fillsettings.FillType:
        ...
    
    ...

class IGradientFillSettings(IFillSettings):
    '''Base interface for fill settings'''
    
    @property
    def color(self) -> aspose.psd.Color:
        '''Gets the color.'''
        ...
    
    @color.setter
    def color(self, value : aspose.psd.Color):
        '''Sets the color.'''
        ...
    
    @property
    def align_with_layer(self) -> bool:
        ...
    
    @align_with_layer.setter
    def align_with_layer(self, value : bool):
        ...
    
    @property
    def dither(self) -> bool:
        '''Gets a value indicating whether this :py:class:`aspose.psd.fileformats.psd.layers.fillsettings.IGradientFillSettings` is dither.'''
        ...
    
    @dither.setter
    def dither(self, value : bool):
        '''Sets a value indicating whether this :py:class:`aspose.psd.fileformats.psd.layers.fillsettings.IGradientFillSettings` is dither.'''
        ...
    
    @property
    def reverse(self) -> bool:
        '''Gets a value indicating whether this :py:class:`aspose.psd.fileformats.psd.layers.fillsettings.IGradientFillSettings` is reverse.'''
        ...
    
    @reverse.setter
    def reverse(self, value : bool):
        '''Sets a value indicating whether this :py:class:`aspose.psd.fileformats.psd.layers.fillsettings.IGradientFillSettings` is reverse.'''
        ...
    
    @property
    def angle(self) -> float:
        '''Gets the angle.'''
        ...
    
    @angle.setter
    def angle(self, value : float):
        '''Sets the angle.'''
        ...
    
    @property
    def scale(self) -> int:
        '''Gets the scale.'''
        ...
    
    @scale.setter
    def scale(self, value : int):
        '''Sets the scale.'''
        ...
    
    @property
    def horizontal_offset(self) -> float:
        ...
    
    @horizontal_offset.setter
    def horizontal_offset(self, value : float):
        ...
    
    @property
    def vertical_offset(self) -> float:
        ...
    
    @vertical_offset.setter
    def vertical_offset(self, value : float):
        ...
    
    @property
    def color_points(self) -> List[aspose.psd.fileformats.psd.layers.IGradientColorPoint]:
        ...
    
    @color_points.setter
    def color_points(self, value : List[aspose.psd.fileformats.psd.layers.IGradientColorPoint]):
        ...
    
    @property
    def transparency_points(self) -> List[aspose.psd.fileformats.psd.layers.fillsettings.IGradientTransparencyPoint]:
        ...
    
    @transparency_points.setter
    def transparency_points(self, value : List[aspose.psd.fileformats.psd.layers.fillsettings.IGradientTransparencyPoint]):
        ...
    
    @property
    def gradient_type(self) -> aspose.psd.fileformats.psd.layers.fillsettings.GradientType:
        ...
    
    @gradient_type.setter
    def gradient_type(self, value : aspose.psd.fileformats.psd.layers.fillsettings.GradientType):
        ...
    
    @property
    def gradient_name(self) -> str:
        ...
    
    @gradient_name.setter
    def gradient_name(self, value : str):
        ...
    
    @property
    def gradient_mode(self) -> aspose.psd.fileformats.psd.layers.gradient.GradientKind:
        ...
    
    @gradient_mode.setter
    def gradient_mode(self, value : aspose.psd.fileformats.psd.layers.gradient.GradientKind):
        ...
    
    @property
    def fill_type(self) -> aspose.psd.fileformats.psd.layers.fillsettings.FillType:
        ...
    
    ...

class IGradientTransparencyPoint:
    '''Base interface for fill settings'''
    
    @property
    def opacity(self) -> float:
        '''Gets the opacity.'''
        ...
    
    @opacity.setter
    def opacity(self, value : float):
        '''Sets the opacity.'''
        ...
    
    @property
    def location(self) -> int:
        '''Gets the location. Value range 0-4096.'''
        ...
    
    @location.setter
    def location(self, value : int):
        '''Sets the location. Value range 0-4096.'''
        ...
    
    @property
    def median_point_location(self) -> int:
        ...
    
    @median_point_location.setter
    def median_point_location(self, value : int):
        ...
    
    ...

class IPatternFillSettings(IFillSettings):
    '''Interface for Pattern fill settings'''
    
    @property
    def angle(self) -> float:
        '''Gets the angle.'''
        ...
    
    @angle.setter
    def angle(self, value : float):
        '''Sets the angle.'''
        ...
    
    @property
    def linked(self) -> bool:
        '''Gets a value indicating whether this :py:class:`aspose.psd.fileformats.psd.layers.fillsettings.IPatternFillSettings` is linked.'''
        ...
    
    @linked.setter
    def linked(self, value : bool):
        '''Sets a value indicating whether this :py:class:`aspose.psd.fileformats.psd.layers.fillsettings.IPatternFillSettings` is linked.'''
        ...
    
    @property
    def scale(self) -> float:
        '''Gets the scale.'''
        ...
    
    @scale.setter
    def scale(self, value : float):
        '''Sets the scale.'''
        ...
    
    @property
    def point_type(self) -> str:
        ...
    
    @point_type.setter
    def point_type(self, value : str):
        ...
    
    @property
    def pattern_name(self) -> str:
        ...
    
    @pattern_name.setter
    def pattern_name(self, value : str):
        ...
    
    @property
    def pattern_id(self) -> str:
        ...
    
    @pattern_id.setter
    def pattern_id(self, value : str):
        ...
    
    @property
    def horizontal_offset(self) -> int:
        ...
    
    @horizontal_offset.setter
    def horizontal_offset(self, value : int):
        ...
    
    @property
    def vertical_offset(self) -> int:
        ...
    
    @vertical_offset.setter
    def vertical_offset(self, value : int):
        ...
    
    @property
    def pattern_data(self) -> List[int]:
        ...
    
    @pattern_data.setter
    def pattern_data(self, value : List[int]):
        ...
    
    @property
    def pattern_width(self) -> int:
        ...
    
    @pattern_width.setter
    def pattern_width(self, value : int):
        ...
    
    @property
    def pattern_height(self) -> int:
        ...
    
    @pattern_height.setter
    def pattern_height(self, value : int):
        ...
    
    @property
    def fill_type(self) -> aspose.psd.fileformats.psd.layers.fillsettings.FillType:
        ...
    
    ...

class NoiseGradientFillSettings(BaseGradientFillSettings):
    '''Noise gradient definition class.'''
    
    @property
    def fill_type(self) -> aspose.psd.fileformats.psd.layers.fillsettings.FillType:
        ...
    
    @property
    def align_with_layer(self) -> bool:
        ...
    
    @align_with_layer.setter
    def align_with_layer(self, value : bool):
        ...
    
    @property
    def dither(self) -> bool:
        '''Gets a value indicating whether this :py:class:`aspose.psd.fileformats.psd.layers.fillsettings.BaseGradientFillSettings` is dither.'''
        ...
    
    @dither.setter
    def dither(self, value : bool):
        '''Sets a value indicating whether this :py:class:`aspose.psd.fileformats.psd.layers.fillsettings.BaseGradientFillSettings` is dither.'''
        ...
    
    @property
    def reverse(self) -> bool:
        '''Gets a value indicating whether this :py:class:`aspose.psd.fileformats.psd.layers.fillsettings.BaseGradientFillSettings` is reverse.'''
        ...
    
    @reverse.setter
    def reverse(self, value : bool):
        '''Sets a value indicating whether this :py:class:`aspose.psd.fileformats.psd.layers.fillsettings.BaseGradientFillSettings` is reverse.'''
        ...
    
    @property
    def angle(self) -> float:
        '''Gets the angle.'''
        ...
    
    @angle.setter
    def angle(self, value : float):
        '''Sets the angle.'''
        ...
    
    @property
    def scale(self) -> int:
        '''Gets the scale.'''
        ...
    
    @scale.setter
    def scale(self, value : int):
        '''Sets the scale.'''
        ...
    
    @property
    def horizontal_offset(self) -> float:
        ...
    
    @horizontal_offset.setter
    def horizontal_offset(self, value : float):
        ...
    
    @property
    def vertical_offset(self) -> float:
        ...
    
    @vertical_offset.setter
    def vertical_offset(self, value : float):
        ...
    
    @property
    def gradient_type(self) -> aspose.psd.fileformats.psd.layers.fillsettings.GradientType:
        ...
    
    @gradient_type.setter
    def gradient_type(self, value : aspose.psd.fileformats.psd.layers.fillsettings.GradientType):
        ...
    
    @property
    def gradient_mode(self) -> aspose.psd.fileformats.psd.layers.gradient.GradientKind:
        ...
    
    @gradient_mode.setter
    def gradient_mode(self, value : aspose.psd.fileformats.psd.layers.gradient.GradientKind):
        ...
    
    @property
    def color_points(self) -> List[aspose.psd.fileformats.psd.layers.IGradientColorPoint]:
        ...
    
    @color_points.setter
    def color_points(self, value : List[aspose.psd.fileformats.psd.layers.IGradientColorPoint]):
        ...
    
    @property
    def transparency_points(self) -> List[aspose.psd.fileformats.psd.layers.fillsettings.IGradientTransparencyPoint]:
        ...
    
    @transparency_points.setter
    def transparency_points(self, value : List[aspose.psd.fileformats.psd.layers.fillsettings.IGradientTransparencyPoint]):
        ...
    
    @property
    def gradient_name(self) -> str:
        ...
    
    @gradient_name.setter
    def gradient_name(self, value : str):
        ...
    
    @property
    def color(self) -> aspose.psd.Color:
        '''Gets the color.'''
        ...
    
    @color.setter
    def color(self, value : aspose.psd.Color):
        '''Sets the color.'''
        ...
    
    @property
    def rnd_number_seed(self) -> int:
        ...
    
    @rnd_number_seed.setter
    def rnd_number_seed(self, value : int):
        ...
    
    @property
    def show_transparency(self) -> bool:
        ...
    
    @show_transparency.setter
    def show_transparency(self, value : bool):
        ...
    
    @property
    def use_vector_color(self) -> bool:
        ...
    
    @use_vector_color.setter
    def use_vector_color(self, value : bool):
        ...
    
    @property
    def roughness(self) -> int:
        '''Roughness factor.'''
        ...
    
    @roughness.setter
    def roughness(self, value : int):
        '''Roughness factor.'''
        ...
    
    @property
    def color_model(self) -> aspose.psd.fileformats.psd.layers.gradient.NoiseColorModel:
        ...
    
    @color_model.setter
    def color_model(self, value : aspose.psd.fileformats.psd.layers.gradient.NoiseColorModel):
        ...
    
    @property
    def minimum_color(self) -> aspose.psd.fileformats.psd.core.rawcolor.RawColor:
        ...
    
    @minimum_color.setter
    def minimum_color(self, value : aspose.psd.fileformats.psd.core.rawcolor.RawColor):
        ...
    
    @property
    def maximum_color(self) -> aspose.psd.fileformats.psd.core.rawcolor.RawColor:
        ...
    
    @maximum_color.setter
    def maximum_color(self, value : aspose.psd.fileformats.psd.core.rawcolor.RawColor):
        ...
    
    ...

class PatternFillSettings(BaseFillSettings):
    '''Pattern fill effect settings'''
    
    @staticmethod
    def generate_lfx_2_resource_nodes(point_type : strcolor : aspose.psd.Color, pattern_name : str, identifier : str, scale : float, linked : bool, offset : aspose.psd.PointF) -> Iterable[aspose.psd.fileformats.psd.layers.layerresources.OSTypeStructure]:
        '''Generates the LFX2 resource nodes.
        
        :param point_type: Type of the point.
        :param color: The color.
        :param pattern_name: Name of the pattern.
        :param identifier: The identifier.
        :param scale: The scale.
        :param linked: if set to ``true`` [linked].
        :param offset: The offset.
        :returns: List of :py:class:`aspose.psd.fileformats.psd.layers.layerresources.OSTypeStructure`'''
        ...
    
    @property
    def fill_type(self) -> aspose.psd.fileformats.psd.layers.fillsettings.FillType:
        ...
    
    @property
    def color(self) -> aspose.psd.Color:
        '''Gets the color.'''
        ...
    
    @color.setter
    def color(self, value : aspose.psd.Color):
        '''Sets the color.'''
        ...
    
    @property
    def linked(self) -> bool:
        '''Gets a value indicating whether this :py:class:`aspose.psd.fileformats.psd.layers.fillsettings.PatternFillSettings` is linked.'''
        ...
    
    @linked.setter
    def linked(self, value : bool):
        '''Sets a value indicating whether this :py:class:`aspose.psd.fileformats.psd.layers.fillsettings.PatternFillSettings` is linked.'''
        ...
    
    @property
    def scale(self) -> float:
        '''Gets the scale.'''
        ...
    
    @scale.setter
    def scale(self, value : float):
        '''Sets the scale.'''
        ...
    
    @property
    def align_with_layer(self) -> bool:
        ...
    
    @align_with_layer.setter
    def align_with_layer(self, value : bool):
        ...
    
    @property
    def point_type(self) -> str:
        ...
    
    @point_type.setter
    def point_type(self, value : str):
        ...
    
    @property
    def pattern_name(self) -> str:
        ...
    
    @pattern_name.setter
    def pattern_name(self, value : str):
        ...
    
    @property
    def pattern_id(self) -> str:
        ...
    
    @pattern_id.setter
    def pattern_id(self, value : str):
        ...
    
    @property
    def horizontal_offset(self) -> int:
        ...
    
    @horizontal_offset.setter
    def horizontal_offset(self, value : int):
        ...
    
    @property
    def vertical_offset(self) -> int:
        ...
    
    @vertical_offset.setter
    def vertical_offset(self, value : int):
        ...
    
    @property
    def pattern_data(self) -> List[int]:
        ...
    
    @pattern_data.setter
    def pattern_data(self, value : List[int]):
        ...
    
    @property
    def pattern_width(self) -> int:
        ...
    
    @pattern_width.setter
    def pattern_width(self, value : int):
        ...
    
    @property
    def pattern_height(self) -> int:
        ...
    
    @pattern_height.setter
    def pattern_height(self, value : int):
        ...
    
    @property
    def angle(self) -> float:
        '''Gets the angle.'''
        ...
    
    @angle.setter
    def angle(self, value : float):
        '''Sets the angle.'''
        ...
    
    ...

class FillType:
    '''The Fill Type'''
    
    @classmethod
    @property
    def COLOR(cls) -> FillType:
        '''The color fill type'''
        ...
    
    @classmethod
    @property
    def GRADIENT(cls) -> FillType:
        '''The gradient fill type'''
        ...
    
    @classmethod
    @property
    def PATTERN(cls) -> FillType:
        '''The pattern fill type'''
        ...
    
    ...

class GradientType:
    '''Gradient type'''
    
    @classmethod
    @property
    def LINEAR(cls) -> GradientType:
        '''The linear gradient type'''
        ...
    
    @classmethod
    @property
    def RADIAL(cls) -> GradientType:
        '''The radial gradient type'''
        ...
    
    @classmethod
    @property
    def ANGLE(cls) -> GradientType:
        '''The angle gradient type'''
        ...
    
    @classmethod
    @property
    def REFLECTED(cls) -> GradientType:
        '''The reflected gradient type'''
        ...
    
    @classmethod
    @property
    def DIAMOND(cls) -> GradientType:
        '''The diamond gradient type'''
        ...
    
    @classmethod
    @property
    def SHAPE_BURST(cls) -> GradientType:
        '''The shape burst gradient type'''
        ...
    
    ...

